openapi: "3.0.1"
info:
  version: "0.0.1"
  title: "API which provides userdata and tour data for the WTBR Webpage"
servers:
  - url: "http://localhost:8080/api/v1"
    description: Local dev server
paths:
  /users:
    get:
      summary: Returns all available users
      tags:
        - users
      operationId: getUsers
      responses:
        '200':
          description: A list of users
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UserList'
    post:
      summary: Add a new User to the database
      tags:
        - users
      security:
        - firebaseAuth: [ ]
      operationId: postUser
      requestBody:
        required: true
        description: The User to create
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/User'
      responses:
        '200':
          description: The created User
          content:
            multipart/form-data:
              schema:
                $ref: '#/components/schemas/User'
        '401':
          $ref: '#/components/responses/UnauthorizedError'


  /users/{firebaseUserId}:
    get:
      summary: Returns one user by fireBaseUserId
      tags:
        - users
      operationId: getUsersById
      parameters:
        - in: path
          name: firebaseUserId
          schema:
            type: string
          required: true
          description: Firebase ID of the user to get
      responses:
        '200':
          description: The requested user
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/User'
        '404':
          description: User not found
  /users/{userId}:
    patch:
      summary: Patch a User
      tags:
        - users
      security:
        - firebaseAuth: [ ]
      operationId: patchUser
      parameters:
        - in: path
          name: userId
          schema:
            type: string
          required: true
          description: ID of the user to get
      requestBody:
        required: true
        description: The User to patch
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/User'
      responses:
        '200':
          description: The updated User
          content:
            multipart/form-data:
              schema:
                $ref: '#/components/schemas/User'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
    delete:
      summary: Delete a User
      tags:
        - users
      security:
        - firebaseAuth: [ ]
      operationId: deleteUser
      parameters:
        - in: path
          name: userId
          schema:
            type: string
          required: true
          description: ID of the user to delete
      responses:
        '200':
          description: Deleted the user sucesfull
        '401':
          $ref: '#/components/responses/UnauthorizedError'



components:
  securitySchemes:
    firebaseAuth:
      type: http
      scheme: bearer

  responses:
    UnauthorizedError:
      description: Access token is missing or invalid

  schemas:
    UserList:
      type: array
      items:
        $ref: '#/components/schemas/User'

    User:
      required:
        - firebaseUid
        - displayName
        - tourRefs
      properties:
        displayName:
          type: string
        firebaseUid:
          type: string
        tourRefs:
          type: array
          items:
            type: string

